# encoding: UTF-8

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

module TIG

  module ArcCenterPointTool

    # Check to see if the selection contains a single arc.
    # If so it returns the arc, otherwise it returns nil
    def self.selected_arc()
      ss = Sketchup.active_model.selection
      return nil unless ss.is_curve?
      edge = ss[0]
      return nil unless edge.is_a?(Sketchup::Edge)
      curve = edge.curve
      return nil unless curve.is_a?(Sketchup::ArcCurve)
      return curve
    end

    # Create a guide point at the center of selected arc
    def self.create_cpoint(arc)
      Sketchup.active_model.active_entities.add_cpoint(arc.center)
    end

    #Context menu...
    unless file_loaded?(File.basename(__FILE__))
      UI.add_context_menu_handler{|menu|
        if arc = self.selected_arc()
          if arc.is_polygon?
            typ = "Polygon"
          elsif (arc.start_angle - arc.end_angle).abs.radians == 360
            typ = "Circle"
          else
            typ = "Arc"
          end
          menu.add_item("Point at Center of #{typ}"){ self.create_cpoint(arc) }
        end
      }
      file_loaded(File.basename(__FILE__))
    end

  end#module
  
end#module
